//+------------------------------------------------------------------+
//|                                                                       Fib Scalp.mq4 |
//|                                                            Copyright 2013, Nuty |
//|                                                                                          |
//|                                                     Version 3.1, 02 March 2013 |
//+------------------------------------------------------------------+
#define VERSION "Version 3.1"
#property copyright "Copyright 2013, Nufty"
#include <stdlib.mqh>

//+------------------------------------------------------------------+
// Expert parameters:
//+------------------------------------------------------------------+
extern int		    MaxTrades = 1;
//extern double 		lots = 0.1;
extern string       EquityRisk="---Enter Percentage Equity overrides Lots---"; 
extern double	    EquityRiskPercent = 1.0;
extern int           TakeProfitFib=161.8;  // Can be set to any number 261.8, 423.6 or any number in between
extern int           StopLossFib=61.8;  // Can be set to any number 0, 23.6, 38.2, 50 or any number in between
extern string       AllowSlip="---Enter Value of Max Slippage---"; 
extern double 		Slip = 3; //Slippage

//extern string       MinAllowChanell="---Enter Value of Min channel to set up Fibs for profit---"; 
//extern double      MinChan = 50; //Channel set to 5 pips (I hope!!)  Havent got this to work - but should get back to it :)

extern int           MagicNumber=10001;
extern string       swi="---Swing High or Low Bar back count---";
extern int           BarSwing=10;  // Number of bars to count high/low for previous swing
extern string       TradeComment="Nufty Manual Trade Sys";

extern string       MA_Mode_Types="0=SMA; 1=EMA; 2=SMMA; 3=LWMA;";

extern int          Fast_MA=14;
extern int          Fast_Mode=1;

extern int          Slow_MA=50;
extern int          Slow_Mode=1;

extern int          Trend_MA=200;
extern int          Trend_Mode=1;

int                     BarsCount = 0;
double      		    upperChannel = 0.0;
double      			lowerChannel = 0.0;
double                POINT_A, POINT_B;

//+------------------------------------------------------------------+
// Global variables
//+------------------------------------------------------------------+
#define DEFAULT_TOLERANCE 0.000000001
#define STANDARDLOT 100000.0
#define MAXTRADESIZE 10.0
#define IS_ECN_BROKER 1

#define MODIFYORDER_DELAY	1000
#define NEXTATTEMPT_DELAY	5000
#define ATTEMPTS_QTY			3


int		m_arrActiveTickets[0];
datetime m_orderCloseTime = 0;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
	
	Print( VERSION);
	InitBrokerPipsMult();

   int nTrades = GetActiveTrades( MagicNumber, m_arrActiveTickets);
   if( nTrades > 0)
   	Print( nTrades,  " active trades are found on Init.");
   
   
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
//int deinit()
//{
    return(0);
//}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
	CheckActiveOrders();

   if( IsNewBar())
      if( ArraySize(m_arrActiveTickets) < MaxTrades)
         if( Time[1] > m_orderCloseTime)
            CheckSignal();

   return(0);
}
//+------------------------------------------------------------------+
// CheckSignal: It's assumed the function is called on NewBar only.
//
// Open a BUY when the price crosses the SMA from below, and the next bar opens above the SMA. 
//
// Open a SELL when the price crosses the SMA from above, and the next bar opens below the SMA.
//
//+------------------------------------------------------------------+
void CheckSignal()
{
 //Trading decision.
   //Examine the filters one by one.
   //Work on the basis that a failed filter turns off SendLong/Short
   
    int type = -1;
    int i;
    double takeLong;
    double takeShort;
    double stopLong;
    double stopShort;
    bool MAFIB= false;
    bool MAFIS = false; 
    //bool Delta = false;
    
    //int MyOrderType;  

   double MA14_prv1 = iMA(NULL, 0, Fast_MA, 0, Fast_Mode, PRICE_CLOSE,1);          
   double MA14_prv2 = iMA(NULL, 0, Fast_MA, 0, Fast_Mode, PRICE_CLOSE,2);         
   double MA14_now = iMA(NULL, 0, Fast_MA, 0, Fast_Mode, PRICE_CLOSE, 0);             
   double MA50_prv1 = iMA(NULL, 0, Slow_MA, 0, Slow_Mode, PRICE_CLOSE, 1);         
   double MA50_prv2 = iMA(NULL, 0, Slow_MA, 0, Slow_Mode, PRICE_CLOSE,2);        
   double MA50_now = iMA(NULL, 0, Slow_MA, 0, Slow_Mode, PRICE_CLOSE, 0);            
   double Trend_MA = iMA(NULL, 0, Trend_MA, 0, Trend_Mode, PRICE_CLOSE,1);             
   
    // Setting Point B as the swing LOW and using open as other point of Fib and Point A as the high
         lowerChannel = Low[ iLowest( NULL, 0, MODE_LOW, BarSwing, 0)];
		 upperChannel = High[ iHighest( NULL, 0, MODE_HIGH, BarSwing, 0)];
    
   // ver 3.1  
   // A BUY signal 


      if((MA14_now > Trend_MA)) MAFIB=true;
         {
         Comment ("EA looking for LONG trades as Price above Trend");
          }
      
      if((MA14_prv1 > MA50_prv1) && (MA14_prv2 < MA50_prv2) && (MA14_now > MA50_now) && (Close[1] < Bid) && MAFIB == true ) 
            {
               Comment ("BUY signal: Fib=", MA14_now, "; Signal Bar Bid=", Bid,"\n");
               Print("BUY signal: Fib=", MA14_now, "; Signal Bar Bid=", Bid);
               type = OP_BUY;
            }
   
        // Setting Point B as the swing LOW and using open as other point of Fib
         POINT_B= Low[ iLowest( NULL, 0, MODE_LOW, BarSwing, 0)];
         
         //take = CalculateTakeProfit(OP_BUY);
         takeLong = POINT_B + ((Open[0] - POINT_B) * TakeProfitFib * 0.01);
         
         //stop = CalculateStopLoss(OP_BUY);
         stopLong = POINT_B + ((Open[0] -POINT_B) * StopLossFib * 0.01);
   
   // A SELL signal 
   
    if (MA14_now < Trend_MA) MAFIS=true;   
     {
     Comment ("EA looking for SHORT trades as Price below", Trend_MA,"\n");
      }
      
    if (( MA14_prv1 < MA50_prv1) && (MA14_prv2 > MA50_prv2) && (MA14_now < MA50_now) && (Close[1] > Ask) && MAFIS == true)
         {
            Comment ("SELL signal: Fib=", MA14_now, "; Signal Bar Ask=", Ask,"\n");
            Print("SELL signal: Fib=", MA14_now, "; Signal Bar Open=", Ask);
            type = OP_SELL;
         }
         
         // Setting Point A as the swing HIGH and using open as other point of Fib
         POINT_A= High[ iHighest( NULL, 0, MODE_HIGH, BarSwing, 0)];

         //take = CalculateTakeProfit(OP_SELL);
         takeShort =  POINT_A - ((POINT_A - Open[0]) * TakeProfitFib * 0.01);
         
         //stop = CalculateStopLoss(OP_SELL);
         stopShort = POINT_A - ((POINT_A - Open[0]) * StopLossFib * 0.01);
   
   
   if( -1 == type)
      return;
    

	// creating new trade:
    //BUY
	
    double lots = MormalizeOrderSize( 0.0);
	if(( EquityRiskPercent > 0.0 && stopLong > 0) && type == OP_BUY)
	{
      {
         lots = LotsByEquityRisk( Symbol(), EquityRiskPercent, Ask, Ask - PipsToPrice( stopLong));
         Print( "Order Size for Risk=", EquityRiskPercent, "% is ", lots);
      }
	
      // the opening:
      int ticket = OpenTrade( type, lots, stopLong, takeLong, MagicNumber);
      if( ticket > 0)
      ArrayAdd( m_arrActiveTickets, ticket);
    }
    
     //SELL
	
   	if(( EquityRiskPercent > 0.0 && stopShort > 0) && type == OP_SELL)
	{
      {
         
         lots = LotsByEquityRisk( Symbol(), EquityRiskPercent, Ask, Ask - PipsToPrice( stopShort));
         Print( "Order Size for Risk=", EquityRiskPercent, "% is ", lots);
      }
	
      // the opening:
      int ticketS = OpenTrade( type, lots, stopShort, takeShort, MagicNumber);
      if( ticketS > 0)
      ArrayAdd( m_arrActiveTickets, ticketS);
    }
    
}

//+------------------------------------------------------------------+
// Check the m_activeTicket is still active;
// Run TrailingStop if necessary
//+------------------------------------------------------------------+
void CheckActiveOrders()
{

   int nTrades = ArraySize( m_arrActiveTickets);
   if( 0 == nTrades)
      return;

	for( int i=nTrades-1 ; i >= 0 ; i--)
	{
      if( false == OrderSelect( m_arrActiveTickets[i], SELECT_BY_TICKET))
      {
        ArrayRemoveAt( m_arrActiveTickets, i);
        continue;
      }
      
	  if( OrderCloseTime() > 0)
	  {
		  Print( "Trade #", m_arrActiveTickets[i], " is closed with P/L=", DoubleToStr( OrderProfit(), 2));
        ArrayRemoveAt( m_arrActiveTickets, i);
		  m_orderCloseTime = Time[0];
	  }
	}

}
//+------------------------------------------------------------------+
// Collects active trades for Symbol().
// If magicNum != 0 then only orders with such MagicNumber are collected.
// Returns a number of found orders.
//+------------------------------------------------------------------+
int GetActiveTrades( int magicNum, int& arrTrades[])
{
   ArrayResize( arrTrades, 0);

   int total = OrdersTotal();
   for( int pos=0 ; pos < total ; pos++)
   {
      if( false == OrderSelect( pos, SELECT_BY_POS))
         continue;

      if( Symbol() == OrderSymbol()  && 0 == OrderCloseTime())
      {
         if( 0 == magicNum  || magicNum == OrderMagicNumber())
         {
            if( OP_BUY == OrderType() || OP_SELL == OrderType())
            {
               ArrayAdd( arrTrades, OrderTicket());
            }
         }
      }
   }

   return( ArraySize( arrTrades));
}
//+------------------------------------------------------------------+
// Opens a trade, StopLoss and TakeProfit in pips
//+------------------------------------------------------------------+
int OpenTrade( int type, double lots, int stopLoss, int takeProfit, int MagicNumber, string comment="")
{
   if ( AccountFreeMarginCheck( Symbol(), type, lots) <= 0.0 && GetLastError() == 134/* NOT_ENOUGH_MONEY */)
   {
      Print( "Not enough money for a new trade.");
      return( 0);
   }

   double price = 0.0;
   double sl = 0.0, tp = 0.0;
   color tradeColor = Green;

   int ticket = 0;
   int errorCode = 0;
   int attempts = ATTEMPTS_QTY;
   if( attempts <= 0 )        attempts = 1;        

   // creating the order:
   while( attempts > 0)
   {
      RefreshRates();
      if( OP_BUY == type)
      {
         price = Ask;
         tradeColor = Green;
         if( 1 != IS_ECN_BROKER)
         {
            if(stopLoss > 0)  sl = price - PipsToPrice( StopLossFib);                
            if(takeProfit > 0) tp = price + PipsToPrice( TakeProfitFib);
         }
      }
      else
      {
         price = Bid;
         tradeColor = Red;
         if( 1 != IS_ECN_BROKER)
         {
            if(stopLoss > 0)  sl = price + PipsToPrice( StopLossFib);                
            if(takeProfit > 0) tp = price - PipsToPrice( TakeProfitFib);
         }
      }

      ticket = OrderSend( Symbol()
         , type
         , lots
         , price
         , Slip
         , sl
         , tp
         , comment
         , MagicNumber
         , 0
         , tradeColor
      );

      if( ticket > 0)
      {
         break;      
      }
      else
      {
         attempts--;
         errorCode = GetLastError(); 
         Print( "Opening trade failed: ", ErrorDescription( errorCode ));

         if( attempts > 0  && !IsCriticalError( errorCode))
         {
            Print( "Next attempt will be made in ", NEXTATTEMPT_DELAY, " milliseconds");
            Sleep( NEXTATTEMPT_DELAY);
            continue;
         }
         else
         {
            return( 0);                    
         }
      }
   }                

   // for ECN - modify for SL and TP
   if( 1 == IS_ECN_BROKER  && ( stopLoss > 0  ||  takeProfit > 0))
   {
      if( MODIFYORDER_DELAY > 0) Sleep( MODIFYORDER_DELAY);

      if( ! OrderSelect( ticket, SELECT_BY_TICKET))
      {
         Print( "Selecting of just created trade failed: ", ErrorDescription( errorCode));
         return( 0);
      }

      price = OrderOpenPrice();
      if( OP_BUY == type)
      {
         if(stopLoss > 0)  sl = price - PipsToPrice( StopLossFib);                
         if(takeProfit > 0) tp = price + PipsToPrice( TakeProfitFib);
      }
      else
      {
         if(stopLoss > 0)  sl = price + PipsToPrice( StopLossFib);                
         if(takeProfit > 0) tp = price - PipsToPrice( TakeProfitFib);
      }

      while( attempts > 0)
      {
         RefreshRates();
         if( OrderModify( ticket, price, sl, tp, 0))
         {
            break;
         }
         else
         {
            errorCode = GetLastError(); 
            Print( "Setting StopLoss and TakeProfit for a new trade failed: ", ErrorDescription( errorCode));

            attempts--;        
            if( attempts > 0 && !IsCriticalError( errorCode))
            {
               Print( "Next attempt will be made in ", NEXTATTEMPT_DELAY, " milliseconds");
               Sleep( NEXTATTEMPT_DELAY);
               continue;
            }
            else
            {
               Print( "The trade is being closed...");
               CloseTrade( ticket);
               ticket = 0;
               break;
            }
         }
      }
   }

   return( ticket);
}
//+------------------------------------------------------------------+
// Cancels the trade, repeats it in case of an error some times.
// In an error the function repeats the attemp ATTEMPTS_QTY times.
//+------------------------------------------------------------------+
bool CloseTrade( int ticket)
{
   if( !OrderSelect( ticket, SELECT_BY_TICKET))
   {
      Print( "Closing the trade #", ticket, ": selecting failed: ", ErrorDescription( GetLastError()));
      return (true);
   }
   if( OrderCloseTime() > 0)
      return( true);
   
   bool isBuy = true;
   if( OP_SELL == OrderType())   isBuy = false;
   double lots = OrderLots();

   double price = 0.0;
   bool success = false;
   
   int attempts = ATTEMPTS_QTY;
   if( attempts <= 0 )	attempts = 1;

   for( int i=0 ; i<attempts  && !success; i++)
   {
      RefreshRates();
      price = Bid;
      if( !isBuy) price = Ask;        
      success = OrderClose( ticket, lots, price, Slip);

      if( ! success)
      {
         Print( "Closing the trade #", ticket, " failed: ", ErrorDescription( GetLastError()));
         if( i < attempts-1)
         {
            Print( "Next attempt will be made in ", NEXTATTEMPT_DELAY, " milliseconds");
            Sleep( NEXTATTEMPT_DELAY);
         }
      }
   }

   if( success)
      Print( "Trade #", ticket, " is closed successfully.");
   return( success);
}
//+------------------------------------------------------------------+
// Init Broker Pips Multiplier (10 for 5 digits brokers, 1 for others)
//+------------------------------------------------------------------+
int BrokerPipsMult = 1;
void InitBrokerPipsMult()
{
   BrokerPipsMult = 1;  
   double commonPoint = 0.0001;
   if( StringFind( Symbol(), "JPY", 0) >= 0 || StringFind( Symbol(), "jpy", 0) >= 0)
      commonPoint = 0.01;
   
   if( 0 != NormalizeDouble( commonPoint - Point, 8))
      BrokerPipsMult = 10;
}
//+------------------------------------------------------------------+
// Converts pips to price for current insturment
//+------------------------------------------------------------------+
double PipsToPrice( double pips)
{
   return( NormalizeDouble( Point * pips * BrokerPipsMult, 6));
}
//+------------------------------------------------------------------+
// Returns true for a new bar.
//+------------------------------------------------------------------+
bool IsNewBar()
{
   static datetime last_time = 0;
   datetime lastbar_time = Time[0];

   if(0 == last_time)
   {  // only just after initialization
      last_time=lastbar_time;
      return( false);
   }

   if(last_time!=lastbar_time)
   {
      last_time = lastbar_time;
      return( true);
   }

   return( false);
}
//+------------------------------------------------------------------+
bool IsCriticalError( int error)
{
	switch( error)
	{
		case 4:	Print("Server is busy, will try again");
					return(false);  
		case 135:Print("Price has changed, will try again");
					return(false);  
		case 136:Print("No prices, will try again");
					return(false);  
		case 137:Print("Broker is busy, will try again");
					return(false);  
		case 146:Print("Terminal is busy, will try again");
					return(false);  
            
		case  2: Print("General error. No trades will be made");
					return(true);  
		case  5: Print("Old version. No trades will be made");
					return(true);  
		case 64: Print("Account is blocked. No trades will be made");
					return(true);  
		case 133:Print("Trade is prohibited. No trades will be made");
					return(true);  
		case 134:Print("Insufficient funds. No trades will be made");
					return(true);  
		default: 
			break;
   }
   
   Print("Error ", ErrorDescription( error), ". No trades will be made"); 
	return(true);  
}

      
            
//+------------------------------------------------------------------+
// Money Management: returns order size in lots so in case of StopLoss
// the order loss equityRistPercent of equity.
//+------------------------------------------------------------------+
double LotsByEquityRisk( string symbol, double equityRistPercent, double openPrice, double stopLoss, double minLots=0.0, double maxLots=0.0)
{
   //if( NULL == symbol)  symbol = Symbol();
   double slPoints = MathAbs( openPrice - stopLoss) / MarketInfo ( symbol, MODE_POINT );
   double loss = AccountEquity() * equityRistPercent * 0.01;
   double lotCost = LotCostPerPoint( symbol );
   if( lotCost <= 0.0)	lotCost = 10.0;
   if( slPoints == 0.0)	slPoints = 100.0;
   double lots = loss / slPoints / lotCost;

   if( minLots > 0.0 && lots < minLots)   lots = minLots;
   if( maxLots > 0.0 && lots > maxLots)   lots = maxLots;

   return( MormalizeOrderSize( lots));
}
//+------------------------------------------------------------------+
// normalize order sise taking into account min size and step:
//+------------------------------------------------------------------+
double MormalizeOrderSize( double size)
{
   double lotStep = MarketInfo( Symbol(), MODE_LOTSTEP);
   double minLot = MarketInfo( Symbol(), MODE_MINLOT);
   int steps = MathRound( size / lotStep);
   double lots = lotStep * steps;
   if( lots < minLot)
      lots = minLot;

   return( lots);
}
//+------------------------------------------------------------------+
// Returns cost of 1 lot when price is changed to 1 POINT
//+------------------------------------------------------------------+
double LotCostPerPoint( string symbol )
{
	if ( MarketInfo ( symbol, MODE_BID ) <= 0 ) {  return(-1.0);  }
	double Cost = -1.0;

	string FirstPart  = StringSubstr( symbol, 0, 3 );
	string SecondPart = StringSubstr( symbol, 3, 3 );

	double Base = MarketInfo ( symbol, MODE_LOTSIZE ) * MarketInfo ( symbol, MODE_POINT );
	if ( SecondPart == "USD" )
	{ 
	  Cost = Base; 
   }
	else
	{
		if ( FirstPart == "USD" )
		{ Cost = Base / MarketInfo ( symbol, MODE_BID ); }
		else
		{
			double bid = MarketInfo( "USD" + SecondPart, MODE_BID );
			if( bid > 0.0 )
				Cost = Base / bid;
			else
				Cost = Base * MarketInfo( SecondPart + "USD", MODE_BID );
		}
	}
   
   return( NormalizeDouble(Cost, 2) );
}
//+------------------------------------------------------------------+
// some methods for adding/remiving/search in an int or double array
//+------------------------------------------------------------------+
int ArrayAdd( int& arr[], int value)
{
	int len = ArraySize( arr);
	if( -1 != ArrayResize( arr, len+1))
		arr[len] = value;
	
	return( len);
}
//+------------------------------------------------------------------+
void ArrayRemoveAt( int& arr[], int idx)
{
	int len = ArraySize( arr);
	if( 0 <= idx  && idx < len)
	{
		for( int i=idx ; i<len-1 ; i++)
			arr[i] = arr[i+1];
		
		ArrayResize( arr, len-1);
	}
}

//+------------------------------------------------------------------+


